/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package command;

import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author student1
 */
public class CommandManager {

    private static CommandManager instance;
    private List<Command> commands;
    private int currentCommand;

    private CommandManager() {
        commands = new ArrayList<>();
        currentCommand = -1;
    }

    public static CommandManager getInstance() {
        if (instance == null) {
            instance = new CommandManager();
        }
        return instance;
    }

    public void execute(Command command) {
        command.execute();
        currentCommand++;
        commands.add(currentCommand, command);
        if (currentCommand < commands.size() - 1) {
            List<Command> commands2 = new ArrayList<>();
            for (int i = 0; i < currentCommand; i++) {
                commands2.add(commands.get(i));
            }
            commands = commands2;
        }

    }

    public void undo() {
        if (currentCommand >= 0) {
            commands.get(currentCommand).undo();
            currentCommand--;
        }
    }

    public void redo() {
        if (currentCommand < commands.size() - 1) {
            currentCommand++;
            commands.get(currentCommand).execute();
        }
    }

}
